# CL L2 V0

## Aims

This is a demo of a CL node that is able to:

- Manage channels via l1 interface (all l1 txs)
- Coordinate channels with other nodes (open, register)
- Send and receive cheques

The repo is a sandbox for the Cardano Lightning's future work. Here we assess
available libraries and designs.

## Setup

This repo use nix flakes with a shell available. Otherwise ymmv.

Build:

```sh
cargo build
```

Run binary `x`:

```sh
cargo run --bin <x>
```

## Current stack

- Comms stack : rust-libp2p
- Persistent storage : sqlx with sqlite

## Design

See the design docs.

## TODO

- [ ] api
  - [ ] global
    - [ ] terms
      - [x] simple
    - [ ] confer
      - [x] simple
    - [ ] watch
    - [ ] register
  - [ ] channel
    - [ ] UNPACK
- [ ] config
  - [ ] UNPACK
- [ ] storage
  - [ ] ephemeral
    - [ ] UNPACK
  - [ ] persistent
    - [ ] UNPACK
- [ ] l1
  - [ ] Mock
    - [ ] UNPACK
  - [ ] Via "kupmios"
