use cryptoxide::{blake2b::Blake2b, digest::Digest};

pub fn hash(msg: &Vec<u8>) -> [u8; 32] {
    let mut digest = [0u8; 32];
    let mut context = Blake2b::new(32);
    context.input(msg);
    context.result(&mut digest);
    digest
}
